<?php

namespace Alive\Dm;

class Plugin {

    private function __construct() {
        if (is_admin()) {
            $this->administration = new Administration();
            $this->ajax = new Ajax();
        } else {
            $this->discount_search = new Discount_Search();
            $this->newest_discounts = new Newest_Discounts();
            $this->discounts_shortcut = new Discounts_Shortcut();
        }
    }

    static function init() {
        $instance = self::instance();

        add_action('init', array($instance, 'init_plugin'));
    }

    public function init_plugin() {
        if (is_admin()) {
            $this->administration->init();
            $this->ajax->init();
        } else {
            $this->discount_search->init();
            $this->newest_discounts->init();
            $this->discounts_shortcut->init();
        }
    }

    private static function instance() {
        static $instance = null;
        if (null === $instance) {
            $instance = new self();
        }
        return $instance;
    }

}
